
#include "arch.h"
//#include "dist.h"
#include "error.h"

#define K 1024
#define M 1024 * 1024

#include <stream.h>
#include <stdlib.h>
#include <string.h>

/*
int initialize(Nodeset& list, Linkset& link)
{
//    Nodeset list = Nodeset("Nodeset0", CPU, 32, 1.0e-8, 1);
    list.append(new Nodeset("Nodeset0", CPU, 32, 1.0e-8, 1)) ;
    list.append(new Nodeset("Nodeset1", Cache, 32, 1, 2)) ;
    list.append(new Nodeset("Nodeset2", Memory, 32, 128, 2)) ;
    list.append(new Nodeset("Nodeset3", Switch, 1, 0, 1)) ;


    link.append(new Linkset("LinksetA", Updown, Full, 321, 0.01, 10*M)) ;
    link.append(new Linkset("LinksetB", Updown, Full, 320, 0.05, 1*M)) ;
    link.append(new Linkset("LinksetC", Updown, Full, 32, 0.1, 500*K)) ;
    
    Linkset * lk = link.locate("LinksetC") ;
    lk->display() ;

// For Nodeset0
    char ** pname = new char* [1] ;
    Linkset ** p = new Linkset* [1] ;
    Nodeset * node = list.locate("Nodeset0") ;
    lk = link.locate("LinksetA") ;
//    pname[0] = new char [strlen("LinksetA")] ;
//    strcpy(pname[0], "LinksetA") ;
    pname[0] = strdup("Nodeset1") ;
    p[0] = lk ;
    node->assign(pname, p) ;
    delete[] pname ;
    delete[] p ;

// For Nodeset1
    pname = new char* [2] ;
    p = new Linkset* [2] ;
    node = list.locate("Nodeset1") ;
    pname[0] = strdup("Nodeset0") ;
    pname[1] = strdup("Nodeset2") ;
    lk = link.locate("LinksetA") ;
    p[0] = lk ;
    p[1] = link.locate("LinksetB") ;
    node->assign(pname, p) ;
    delete[] pname ;
    delete[] p ;
    
// For Nodeset2
    pname = new char* [2] ;
    p = new Linkset* [2] ;
    node = list.locate("Nodeset2") ;
    pname[0] = strdup("Nodeset1") ;
    pname[1] = strdup("Nodeset3") ;
    lk = link.locate("LinksetB") ;
    p[0] = lk ;
    p[1] = link.locate("LinksetC") ;
    node->assign(pname, p) ;
    delete[] pname ;
    delete[] p ;

// For Nodeset3
    pname = new char* [1] ;
    p = new Linkset* [1] ;
    node = list.locate("Nodeset3") ;
    pname[0] = strdup("Nodeset2") ;
    p[0] = link.locate("LinksetC") ;
    node->assign(pname, p) ;
    delete[] pname ;
    delete[] p ;

// For LinksetA
    lk = link.locate("LinksetA") ;
    lk->assign("Nodeset0", "Nodeset1") ;

// For LinksetB
    lk = link.locate("LinksetB") ;
    lk->assign("Nodeset1", "Nodeset2") ;

// For LinksetC
    lk = link.locate("LinksetC") ;
    lk->assign("Nodeset2", "Nodeset3") ;

    node = list.locate("Nodeset2") ;
    node->display() ;
    
    node = list.locate("Nodeset2") ;
    lk = node->getlink("Nodeset1") ;
    lk->display() ;

    return 0 ;
}
*/


int initialize(Nodeset& list, Linkset& link) {
    char name[40], Type[10], Dupl[10] ;
    char s_number[40], s_latency[40], s_band[40] ;
    Linktype type ;
    Duplex dupl;
    int number;
    float latency ;
    long band ;
    char begin[40], end[40] ;

    char **ptr = new char * [1] ;

// to construct the linkset object
#ifdef DEBUG
cout << "In initialize ... " << endl ;
#endif

    ifstream link_file("linkset.ini") ;
    while (!link_file.eof()) {
	if (link_file >> name >> Type >> Dupl >> s_number >> s_latency 
		>> s_band >> begin >> end) {
//	    cout << name << type << dupl << number << latency ;
//	    cout << band << begin << end << endl ;

	    number = (int) strtol(s_number, ptr, 10) ;
	    if (*ptr != s_number+strlen(s_number)) input_error(s_number) ;

	    latency = strtod(s_latency, ptr) ;
	    if (*ptr != s_latency+strlen(s_latency)) input_error(s_latency) ;

	    band = strtol(s_band, ptr, 10) ;
	    if (*ptr != s_band+strlen(s_band)) input_error(s_band) ;

	    if (!strcmp(Type, "Updown")) type = Updown ;
	    else if (!strcmp(Type, "Across")) type = Across ;
	    else {
		cerr << "No such Linkset type : " << Type << endl ;
		exit(-1) ;
	    }

	    if (!strcmp(Dupl, "Full")) dupl = Full ;
	    else if (!strcmp(Dupl, "Half")) dupl = Half ;
	    else {
		cerr << "No such duplex type : " << Dupl << endl ;
		exit(-1) ;
	    }
	    
	    link.append(new Linkset(name, type, dupl, number, latency, band)) ;
	    Linkset* lk = link.locate(name) ;
	    if ( !lk ) error(name) ;
	    lk->assign(begin, end) ; 
//	    lk->display() ;
	}

    }

// to construct the nodeset object

    char s_size[40], s_ports[40] ;
    long size ;
    float speed ;
    int ports ;
    NodeType nodetype ;
    char portname[40], linkname[40] ;
    ifstream node_file("nodeset.ini") ;
    while(!node_file.eof()) {
	if (node_file >> name >> Type >> s_number >> s_size >>  s_ports) {
//	    cout << name << Type << number << size << ports << endl ;

	    number = (int) strtol(s_number, ptr, 10) ;
	    if (*ptr != s_number+strlen(s_number)) input_error(s_number) ;

	    size = strtoll(s_size, ptr, 10) ;
	    if (*ptr != s_size+strlen(s_size)) input_error(s_size) ;

	    ports = (int) strtol(s_ports, ptr, 10) ;
	    if (*ptr != s_ports+strlen(s_ports)) input_error(s_ports) ;

	    if (!strcmp(Type, "CPU")) node_file >> s_latency ;

	    speed = strtod(s_latency, ptr) ;
	    if (*ptr != s_latency+strlen(s_latency)) input_error(s_latency) ;

	    char ** pname = new char* [ports] ;
	    Linkset ** p = new Linkset* [ports] ;

	    for (int i = 0; i < ports; i++) {
		node_file >> portname >> linkname ;
//		cout << portname << " " << linkname << endl ;
	
		pname[i] = strdup(portname) ;
		if ( !(p[i] = link.locate(linkname)) ) error(linkname) ;
	    }

	    if (!strcmp(Type, "CPU")) nodetype = CPU ;
	    else if (!strcmp(Type, "Cache")) nodetype = Cache ;
	    else if (!strcmp(Type, "Memory")) nodetype = Memory ;
	    else if (!strcmp(Type, "Disk")) nodetype = Disk ;
	    else if (!strcmp(Type, "Switch")) nodetype = Switch ;
	    else {
		cerr << "No such Nodeset type : " << Type << endl ;
		exit (-1) ;
	    }

	    if ( type == CPU )
	        list.append(new Nodeset(name, nodetype, number, size, ports)) ;
	    else
	        list.append(new Nodeset(name, nodetype, number, size, ports, 
				speed)) ;

	    Nodeset* node = list.locate(name) ;
	    if ( !node ) error(name) ;
	    node->assign(pname, p) ;
	
	    delete[] pname ;
	    delete[] p ;
	  
	}
    }

    return 0 ;
}

int dataset_init(Dataset& dataset) {
    char name[40] ;
    char Type[40] ;
    Datasettype type ;
    long size ;
    int bytes, floats, opers ;

    char s_size[40], s_bytes[40], s_floats[40], s_opers[40] ;
    char **ptr = new char * [1] ;

// to construct dataset object
// right now, only support one dataset
#ifdef DEBUG
cout << "In dataset_init ... " << endl ;
#endif

    ifstream data_file("dataset.ini") ;
    while (!data_file.eof()) {
	if (data_file >> name >> Type >> s_size >> s_bytes 
		>> s_floats >> s_opers) {

	    size = strtol(s_size, ptr, 10) ;
	    if (*ptr != s_size+strlen(s_size)) input_error(s_size) ;

	    bytes = (int) strtol(s_bytes, ptr, 10) ;
	    if (*ptr != s_bytes+strlen(s_bytes)) input_error(s_bytes) ;

	    floats = (int) strtol(s_floats, ptr, 10) ;
	    if (*ptr != s_floats+strlen(s_floats)) input_error(s_floats) ;

	    opers = (int) strtol(s_opers, ptr, 10) ;
	    if (*ptr != s_opers+strlen(s_opers)) input_error(s_opers) ;

	    if (!strcmp(Type, "Grid1dim")) type = Grid1dim ;
	    else if (!strcmp(Type, "Grid2dim")) type = Grid2dim ;
	    else if (!strcmp(Type, "Grid3dim")) type = Grid3dim ;
	    else {
		cerr << "No such Dataset type : " << Type << endl ;
		exit (-1) ;
	    }

//	    dataset = *(new Dataset(name, type, size, bytes, floats)) ;
	    dataset.append(new Dataset(name, type, size, bytes, floats, 
				opers)) ;
	}
    }

    return 0 ;
}


int distribution_init(Distribution& distset) {
    char name[40] ;
    char Type[40] ;
    Distype type ;

// to construct Distribution
#ifdef DEBUG
cout << "In distribution_init ... " << endl ;
#endif

    ifstream dist_file("dist.ini") ;
    while (!dist_file.eof()) {
        if (dist_file >> name >> Type) {
            if (!strcmp(Type, "Block1dim")) type = Block1dim ;
            else if (!strcmp(Type, "Block2dim")) type = Block2dim ;
            else if (!strcmp(Type, "Block3dim")) type = Block3dim ;
            else {
                cerr << "No such Distribution type : " << Type << endl ;
                exit (-1) ;
            }

            distset.append(new Distribution(name, type)) ;
        }
    }

    return 0 ;
}



int main() {
    Nodeset nodeset ;
    Linkset linkset ;

 
#ifdef DEBUG
cout << "Test Begin ... " << endl ;
#endif

    initialize(nodeset, linkset) ;

//    Dataset dataset("Jacobi", Grid2dim, 1000000, 4, 4) ;
    Dataset dataset ;
    dataset_init(dataset) ;

    Distribution distribution ;
    distribution_init(distribution) ;

/*
    Distribution* dist = distribution.locate("Jacobi2dim") ;
    dist->display() ;

    Dataset* data = dataset.locate("Jacobi") ;

    cout << "Simulator ........" << endl << endl ;

    Nodeset* node = nodeset.locate("Nodeset0") ;
    cout << "calculate : " << node->calculate(data) << endl ;

    float cost = 0;

//  Send Jacobi from Nodeset2 to Nodeset1
    cost += data->transmit(nodeset, "Nodeset2", "Nodeset1") ;

    cost += data->transmit(nodeset, "Nodeset1", "Nodeset0") ;
    cost += data->update(nodeset, "Nodeset0") ;
   
    cout << "Total cost is estimated to be : " << cost << " s" <<endl ;
*/

    float estimate(Nodeset& nodeset, Linkset& linkset, Dataset& dataset,
                Distribution& distribution) ;

    estimate(nodeset, linkset, dataset, distribution) ;

}
